package jrummikub.ai.fdsolver.constraint;

import java.util.Arrays;
import java.util.Collection;
import java.util.Iterator;

import jrummikub.ai.fdsolver.Propagator;
import jrummikub.ai.fdsolver.Var;

public class FilterPropagator<T> implements Propagator {
	private Filter<T> filter;
	private Var<T> var;
	
	public FilterPropagator(Filter<T> filter, Var<T> var) {
		this.filter = filter;
		this.var = var;	
	}
	
	@Override
	public Collection<Var<?>> getWatchedVars() {
		return Arrays.<Var<?>>asList(var);
	}

	@Override
	public void propagate() {
		for(Iterator<T> i = var.iterator(); i.hasNext();) {
			if(!filter.accept(i.next()))
				i.remove();
		}
	}
}
